<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Thorsten Wst (t.wuest@wuest-media.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Tw Rss Feeds' for the 'tw_rssfeeds' extension.
 *
 * @author	Thorsten Wst <t.wuest@wuest-media.de>
 */

require_once (PATH_t3lib . 'class.t3lib_xml.php');
require_once(PATH_tslib."class.tslib_pibase.php");

class tx_twrssfeeds_pi1 extends tslib_pibase {
	var $prefixId = "tx_twrssfeeds_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_twrssfeeds_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "tw_rssfeeds";	// The extension key.
	
	########################################################
	########### set vars for parser #######################
	######################################################
	
	var $parser;
	var $case_folding = TRUE;
	var $data = array();
	var $current_tag = '';
	var $item_count = 0;
	var $image_flag = false;
	var $input_flag = false;
	var $channel_flag = false;
	var $item_flag = false;
	
	
	
	
	
	/**
	 * [check out flexforms values..]
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm(); //init the flexes :)
		
		$GLOBALS["TSFE"]->set_no_cache();
	
		$content="";
		$get_url = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'goforurl', 'sDEF');
		$this->conf['url'] = $get_url ? $get_url:$this->conf['url'];
		
		if($get_url!==""){
			$get_thefeed = $get_url;
		}
		
		if($this->conf['url']!==""){
			$get_thefeed = $this->conf['url'];
		}
		
		if($get_url=="" && $this->conf['url']==""){
			return"Es wurde keine URL eingegeben. Bitte machen Sie es so!";
		}		
		
		
		$content.= $this->parseRSS($get_thefeed);
		return $content;
	}//end of main
	
	
function parseRSS($file)  {
	
	#########################################################################
	################### other flexform values for tryout ###################
	#######################################################################
	
	$get_maxitems = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'gomaxitems', 'sDEF');
	$this->conf['maxItem'] = $get_maxitems ? $get_maxitems:$this->conf['maxItem'];
	
		if($get_maxitems!==""){
			$get_themaxitems = $get_maxitems;
		}
		
		if($this->conf['maxItem']!==""){
			$get_themaxitems = $this->conf['maxItem'];
		}
		
		if($get_maxitems=="" && $this->conf['maxItem']==""){
			return"Es wurde keine maximale Anzahl von Objekten eingegeben. Bitte machen Sie es so!";
		}
	
	$DescSeparator = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'descSeps', 'sDEF');
	$this->conf['DescSeparator'] = $DescSeparator ? $DescSeparator:$this->conf['DescSeparator'];
	
		if($DescSeparator!==""){
			$get_thedescsep = $DescSeparator;
		}
		
		if($this->conf['maxItem']!==""){
			$get_thedescsep = $this->conf['DescSeparator'];
		}
		
		if($DescSeparator=="" && $this->conf['DescSeparator']==""){
			$get_thedescsep = "";
		}	

	$ItemSeparator = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'itemSeps', 'sDEF');
	$this->conf['ItemSeparator'] = $ItemSeparator ? $ItemSeparator:$this->conf['ItemSeparator'];
	
		if($ItemSeparator!==""){
			$get_theItemSeparator = $ItemSeparator;
		}
		
		if($this->conf['ItemSeparator']!==""){
			$get_theItemSeparator = $this->conf['ItemSeparator'];
		}
		
		if($ItemSeparator=="" && $this->conf['ItemSeparator']==""){
			return"Es wurden keine Objektrenner angegeben. Bitte machen Sie es so!";
		}	

	$LinkTarget = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'linktarget', 'sDEF');
	$this->conf['LinkTarget'] = $LinkTarget ? $LinkTarget:$this->conf['LinkTarget'];
	
		if($LinkTarget!==""){
			$get_theLinkTarget = $LinkTarget;
		}
		
		if($this->conf['LinkTarget']!==""){
			$get_theLinkTarget = $this->conf['LinkTarget'];
		}
		
		if($LinkTarget=="" && $this->conf['LinkTarget']==""){
			$get_theLinkTarget = "_blank";
		}
		
	$SubmitValue = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'subdesc', 'sDEF');
	$this->conf['SubmitValue'] = $SubmitValue ? $SubmitValue:$this->conf['SubmitValue'];
	
		if($SubmitValue!==""){
			$get_theSubmitValue = $SubmitValue;
		}
		
		if($this->conf['SubmitValue']!==""){
			$get_theSubmitValue = $this->conf['SubmitValue'];
		}
		
		if($SubmitValue=="" && $this->conf['SubmitValue']==""){
			$get_theSubmitValue = "Submit";
		}			

	$ChannelDesc = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'channeldesc', 'specificfeeds');
	$this->conf['ChannelDesc'] = $ChannelDesc ? $ChannelDesc:$this->conf['ChannelDesc'];
	
		if($ChannelDesc!==""){
			$get_theChannelDesc = $ChannelDesc;
		}
		
		if($this->conf['ChannelDesc']!==""){
			$get_theChannelDesc = $this->conf['ChannelDesc'];
		}
		
		if($ChannelDesc=="" && $this->conf['ChannelDesc']==""){
			$get_theChannelDesc = "FALSE";
		}	

	$ItemDesc = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'itemdesc', 'specificfeeds');
	$this->conf['ItemDesc'] = $ItemDesc ? $ItemDesc:$this->conf['ItemDesc'];
	
		if($ItemDesc!==""){
			$get_theItemDesc = $ItemDesc;
		}
		
		if($this->conf['ItemDesc']!==""){
			$get_theItemDesc = $this->conf['ItemDesc'];
		}
		
		if($ItemDesc=="" && $this->conf['ItemDesc']==""){
			$get_theItemDesc = "FALSE";
		}

	$Image = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'imagedesc', 'specificfeeds');
	$this->conf['Image'] = $ItemDesc ? $ItemDesc:$this->conf['Image'];
	
		if($Image!==""){
			$get_theImage = $Image;
		}
		
		if($this->conf['Image']!==""){
			$get_theImage = $this->conf['Image'];
		}
		
		if($Image=="" && $this->conf['Image']==""){
			$get_theImage = "FALSE";
		}

	$Textinput = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'textdesc', 'specificfeeds');
	$this->conf['Textinput'] = $ItemDesc ? $ItemDesc:$this->conf['Textinput'];
	
		if($Textinput!==""){
			$get_theTextinput = $Textinput;
		}
		
		if($this->conf['Textinput']!==""){
			$get_theTextinput = $this->conf['Textinput'];
		}
		
		if($Textinput=="" && $this->conf['Textinput']==""){
			$get_theTextinput = "FALSE";
		}	

	$this->getRSSData($file);

	if ($get_themaxitems < $this->item_count) {
		$this->item_count = $get_themaxitems;
	}
	
	################################################################################
	############################## startting with a div table #####################
	##############################################################################
	
	$content .= '<DIV id=twrss_table>';
	$content .= '<DIV class="twrss_head_channel">'.$this->data['CHANNEL']['TITLE'].'</DIV>';
	$content .= $get_thedescsep;
        if ($get_theChannelDesc == true) {
	    	$content .= '<DIV class=twrss_bodytext>'.$this->data['CHANNEL']['DESCRIPTION'].'</DIV>';
        	$content .= $get_thedescsep;
        }
        
        $content .='<DIV class=twrss_bodytext><A href="'.$this->data['CHANNEL']['LINK'].'" target="'.$get_theLinkTarget.'">'.$this->data['CHANNEL']['LINK'].'</A></DIV>';
        $content .= $get_thedescsep;  
	
	################################################################################
	######### Image - Section - we get the image and place it in the content ######
    	##############################################################################
    	
    	if ($get_theImage == true && isset($this->data['IMAGE'])) {  
    		$content .='<A href="'.$this->data['IMAGE']['LINK'].'" target="'.$get_theLinkTarget.'">';            	
		$content .= '<IMG src="'.$this->data['IMAGE']['URL'].'" alt="'.@$this->data['IMAGE']['TITLE'].'" border="0"';
			if (isset($this->data['IMAGE']['WIDTH']))
				$content .= ' width="'.$this->data['IMAGE']['WIDTH'].'"';
			if (isset($this->data['IMAGE']['HEIGHT']))
				$content .= ' height="'.$this->data['IMAGE']['HEIGHT'].'"';
	            $content .= '>';
	            $content .= '</A>';
	        }
	$content .= $get_theItemSeparator;  
	for ($i = 1; $i <= $this->item_count; $i++)  {
		$content .='<DIV class=twrss_bodytext><A href="'.$this->data['ITEM'][$i]['LINK'].'" target="'.$get_theLinkTarget.'" >'.$this->data['ITEM'][$i]['TITLE'].'</A></DIV>';
    		$content .= $get_thedescsep;
	if ($this->conf['ItemDesc'] == true && isset($this->data['ITEM'][$i]['DESCRIPTION'])) {
	    	$content .= '<DIV class=twrss_bodytext>'.$this->data['ITEM'][$i]['DESCRIPTION'].'</DIV>';
            $content .= $get_thedescsep;
        }
        
        $content .= $get_theItemSeparator;
	}
	
	
    if ($get_theTextinput == true && isset($this->data['TEXTINPUT'])) {	
	    	$content .= '<DIV class=twrss_bodytext>'.$this->data['TEXTINPUT']['TITLE'].'</DIV>';
                $content .= $get_thedescsep;
	    	$content .= '<DIV class=twrss_bodytext>'.$this->data['TEXTINPUT']['DESCRIPTION'].'</DIV>';
                $content .= $get_thedescsep;
                $content .= '<FORM action="'.$this->data['TEXTINPUT']['LINK'].'" method="post" target="'.$get_theLinkTarget.'">';
                $content .= '<INPUT type="text" class=twrss_bodytext name="'.$this->data['TEXTINPUT']['NAME'].'">';
                $content .= '<INPUT type="submit" class=twrss_bodytext value="'.$get_theSubmitValue.'">';
                $content .= '</FORM>';
                $content .= $get_theItemSeparator;
                }             
   	$content.= '</DIV>';
   	return $content;
}

	####################################################
	######### take the rss file #######################
	################################################## 

	  function getRSSData($file)
	  {
	   $this->set_parser();
	   $this->xml_file($file);
	   return $this->data;
	  }
	
	
	############################################################
	############# starting element begins here ################
	##########################################################
	
	  function startElement($parser, $tag, $attribute) {
	
		if (strtoupper(substr($tag,0,3)) == 'RDF') {
			$tag = substr($tag,4,strlen($tag));
		}
	
	  $this->current_tag = $this->StringToUpper($tag);
	
	  	if ($this->StringToUpper($tag) == 'CHANNEL') {
	  	   $this->channel_flag = true;
	  	}
	
	  	if ($this->StringToUpper($tag) == 'IMAGE') {
	  		$this->image_flag = true;
	  	}
	
	  	if ($this->StringToUpper($tag) == 'TEXTINPUT') {
	  		$this->input_flag = true;
	  	}
	
	  	if ($this->StringToUpper($tag) == 'ITEM') {
	  		$this->item_flag = true;
	  		$this->item_count++;
	  	}
	  }
	
	#############################################################
	######### end element ######################################
	###########################################################
	
	  function endElement($parser, $tag) {
	
		if ($this->StringToUpper($tag) == 'CHANNEL') {
		 	$this->channel_flag = false;
		}
	
	  	if ($this->StringToUpper($tag) == 'IMAGE') {
	  		$this->image_flag = false;
	  	}
	
	  	if ($this->StringToUpper($tag) == 'TEXTINPUT') {
	  		$this->input_flag = false;
	  	}
	
	  	if ($this->StringToUpper($tag) == 'ITEM') {
	  		$this->item_flag = false;
	  	}
	  }
	
	#############################################################
	########## set the flags to display content ################
	###########################################################
	
	  function getCharacterData($parser, $cdata) {
	
	  	if ($this->channel_flag == true && $this->item_flag == false && $this->image_flag == false && $this->input_flag == false)  {
	  		if ($this->current_tag != 'CHANNEL')  {
	  				if (!isset($this->data['CHANNEL'][$this->current_tag])) {
						$this->data['CHANNEL'][$this->current_tag] = '';
	  				}
	  			$this->data['CHANNEL'][$this->current_tag] .= $cdata;
			}
	    }
	
		if ($this->image_flag == true)  {
	  		if ($this->current_tag != 'IMAGE')  {
	  				if (!isset($this->data['IMAGE'][$this->current_tag])) {
						$this->data['IMAGE'][$this->current_tag] = '';
	  				}
				$this->data['IMAGE'][$this->current_tag] .= $cdata;
			}
	    }
	
		if ($this->input_flag == true)  {
	  		if ($this->current_tag != 'TEXTINPUT')  {
	  				if (!isset($this->data['TEXTINPUT'][$this->current_tag])) {
						$this->data['TEXTINPUT'][$this->current_tag] = '';
	  				}
				$this->data['TEXTINPUT'][$this->current_tag] .= $cdata;
			}
	    }
	
		if ($this->item_flag == true)  {
	  		if ($this->current_tag != 'ITEM')  {
	  				if (!isset($this->data['ITEM'][$this->item_count][$this->current_tag])) {
						$this->data['ITEM'][$this->item_count][$this->current_tag] = '';
	  				}
				$this->data['ITEM'][$this->item_count][$this->current_tag] .= $cdata;
			}
	    }
	  }   
	
	#######################################################################################
	############# xml file ###############################################################
	#####################################################################################
	
	  function xml_file($file)
	  {
	   if (!($fp = @fopen($file, "r")))
	     $this->error("Kann XML-Datei <b>".$file."</b> nicht ffnen");
	
	   while($data = fread($fp, 4096))
	     {
	      if (!(xml_parse($this->parser,$data)))
	        $this->error("XML-Output: ".xml_error_string(xml_get_error_code($this->parser)));
	     }
	
	    xml_parser_free($this->parser);
	  }
	
	
	######################################################################################
	################# xml processing with php parsers ###################################
	####################################################################################
		 
	  function set_parser()
	  {
	   $this->parser = xml_parser_create();
	   xml_set_object($this->parser, &$this);
	   xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, $this->case_folding);
	   xml_set_element_handler($this->parser,"startElement","endElement");
	   xml_set_character_data_handler($this->parser,"getCharacterData");
	  }	 
		
	  function StringToUpper($tagname)
	  {
	   if ($this->case_folding)
	    return strtoupper($tagname);
	   else
	    return $tagname;
	  }	
		
	  function error($msg)
	  {
	   die(printf("Fehler: %s", $msg));
	  }	
	
	
}//end of class



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tw_rssfeeds/pi1/class.tx_twrssfeeds_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tw_rssfeeds/pi1/class.tx_twrssfeeds_pi1.php"]);
}

?>